Subject: Re: Lisp song (fwd)

From: Moshe Zadka <[email-masked]>
Date: Tue, 16 May 2000 23:31:39 +0300 (IDT)

Sorry for the HTML posting, I'm just forwarding it.
Anyhow, thought it would be interesting.

--
Moshe Zadka <[email-masked]>
http://www.oreilly.com/news/prescod_0300.html
http://www.linux.org.il -- we put the penguin in .com

---------- Forwarded message ----------
Date: Mon, 15 May 2000 16:25:53 +0100 (BST)
From: Tim Bradshaw <[email-masked]>
To: [email-masked]
Subject: Re: Lisp song

* Moshe Zadka wrote:

> I'd be delighted if you send it to me.

It looks like I converted it to HTML at some point, even

--tim
Alice's Lisp machine

Chris Stacy, Alan Wecsler and Noel Chia, AIlist digest Thu 5 Dec 1985

This song is called ``MIT's AI Lab''. It's about MIT and the AI Lab, but ``MIT's AI Lab'' is not the name of the lab, that's just the name of the song. That's why I call the song ``MIT's AI Lab.''

Now it all started two full dumps ago, on Thanksgiving, when my friend and I went up to visit the hackers at AI lab on the ninth floor. But the hackers don't always live on the ninth floor, they just go there to use these complex order code stack machines they call Lisp Machines.

And using a special purpose processor like that, they got a lot of room upstairs where DDT used to be, and havin' all that ROOM they decided that they didn't have to collect any garbage for a long time.

We JFCLed up here and found all the garbage in there and we decided that it'd be a friendly gesture for us to take all the garbage down to the system dump.

So we took the half-a-meg of garbage, put it in the back of a red ECL Multibus, took subrs and hacks and implementations of defstruction, and headed on toward the system dump.

Well, we got there and there was a big pop up window and a write protect across the dump sayin', ``This Garbage Collecter Under Development on Thanksgiving,'' and we'd never heard of a garbage collector NOP'd out on Thanksgiving before, and with tears in our eyes, we CDR'd off into the sunset lookin' for another place to put the garbage.

We didn't find one 'til we came to a side area, and off the side of the side area was three hundred megabyte disk, and in the middle of the disk was another heap of garbage. And we decided that one big heap was better than two little heaps, and rather than page that one in, we decided to write ours out. That's what we did.

Branched back to the Lisp Listener, had a Chinese Thanksgiving dinner that couldn't be beat, went to SI:PROCESS-WAIT SLEEP, and didn't get up until the next quantum, when we got a funcall from Mr. Greenblatt. He said, ``Kid, we found your name on a cons at the bottom of a half-a-meg of garbage and I just wanted to know if you had any information about it''.

And I said, ``Yes sir, Mr. Greenblatt, I cannot tell a lie. I put that structure under that garbage.'' After speakin' to Greenblatt for about forty-five million clock ticks on the telnet stream, we finally arrived at the truth of the matter and he said that we had to go down and link up the garbage, and also had to go down and speak to him at the Lisp Machine Factory. So we got in the red ECL Multibus with the subrs and hacks and implementations of defstruction and headed on toward the Lisp Machine Factory.

Now, friends, there was only one of two things that Greenblatt could've done at the Lisp Machine Factory, and the first was that he could've given us another 64K board for bein' so brave and honest on BUG-LISPM (which wasn't very likely, and we didn't expect it), and the other thing was that he could've flamed at us and told us never to be seen BLTing garbage around in the vicinity again, which is what we expected.

But when we got to the Lisp Machine Factory, there was a third COND-clause that we hadn't even counted upon, and we was both immediately Process-Arrested, Deexposed, and I said, ``Greenblatt, I can't GC up the garbage with these here ARREST-REASONS on''. He said: ``Output-Hold, kid, and get in the back of the Control CAR.'' ... And that's what we did ... sat in the back of the Control CAR, and drove to the sharpsign quote open scene-of-the-crime close.

I wanna tell you 'bout the town of Cambridge, Massachusetts, where this is happenin'. They got seven hunnert stop signs, no turn on red, and two campus police CARs, but when we got to the sharpsign-quote-open scene-of-the-crime close, there was five Lisp Machine hackers and three scope carts, bein' the biggest hack of the last ten years and everybody wanted to get in the HUMAN-NETS story about it.

And they was usin' up all kinds of digital equipment that they had hangin' around the Lisp Machine Factory. They was takin' backtraces, stack traces, plastic wire wraps, blueprints, and microcode loads ... And they made seventeen 1K-by-32 pixel multi-flavored windows with turds and arrows and a scroll bar on the side of each one with documentation panes explainin' what each one was, to be used as evidence against us.
.... Took pictures of the labels, blinkers, the cursors, the pop up notification windows, the upper right corner, the lower left corner ....and that's not to mention the XGP'd screen images!

After the ordeal, we went back to the Factory. Greenblatt said he was gonna locate us in a cell. He said: ``Kid, I'm gonna INTERN you in a cell. I want your manual and your mouse.''

I said, ``Greenblatt, I can understand your wantin' my manual, so I don't have any documentation about the cell, but what do you want my mouse for?'' and he said, ``Kid, we don't want any window system problems''. I said, ``Greenblatt, did you think I was gonna deexpose myself for litterin'?''

Greenblatt said he was makin' sure, and, friends, Greenblatt was, 'cause he took out the left Meta-key so I couldn't double bucky the rubout and cold-boot, and he took out the Inspector so I couldn't click-left on Modify, set the PROCESS-WARM-BOOT-ACTION on the window, *THROW around the UNWIND-PROTECT and have an escape. Greenblatt was makin' sure.

It was about four or five hours later that Moon--(remember Moon? This here's not a song about Moon)-- Moon came by and, with a few nasty sends to Greenblatt on the side, bailed us out of core, and we went up to the Loft, had another Chinese dinner that couldn't be beat, and didn't get up until the next evening, when we all had to go to court.

We walked in, sat down, Greenblatt came in with the seventeen 1K-by-32 pixel multi-flavored windows with turds and arrows and documentation panes, sat down.

McMahon came in, said, ``All rise!'' We all stood up, and Greenblatt stood up with the seventeen 1K-by-32 pixel multi-flavored windows with turds and arrows and documentation panes, and the judge walked in, with an LA36, and he sat down. We sat down.

Greenblatt looked at the LA36... then at the seventeen multi flavored windows with the turds and arrows and documentation panes... and looked at the LA36... and then at the seventeen 1K-by-32 pixel multi-flavored windows with turds and arrows and documentation panes, and began to cry.

Because Greenblatt came to the realization that it was a typical case of LCS state-of-the-art technology, and there wasn't nothin' he could do about it, and the judge wasn't gonna look at the seventeen 1K-by-32 pixel multi-flavored windows with turds and arrows and documentation panes, explainin' what each one was, to be used as evidence against us.

And we was fined fifty zorkmids and had to rebuild the world load ... in the snow.

But that's not what I'm here to tell you about. I'm here to talk about the Lab.

They got a buildin' down in Cambridge called Technology Square, where you walk in, you get your windows Inspected, detected, neglected and Selected!

I went down and got my interview one day, and I walked in, sat down (slept on the beanbag in 926 the night before, so I looked and felt my best when I went in that morning, 'cause I wanted to look like the All-American High School Tourist from Sunnyvale. I wanted to feel like ... I wanted to be the All-American Kid from Sunnyvale), and I walked in, sat down, I was gunned down, brung down, locked out and all kinds of mean, nasty, ugly things.

And I walked in, I sat down, KAREN gave me a piece of paper that said: ``Kid, see the CLU hackers on XX.''

I went up there, I said, ``Eliot, I wanna lose. I wanna lose! I wanna see hacks and kludges and unbound variables and cruft in my code! Eat dead power supplies with cables between my teeth! I mean lose! lose! lose!''

And I started jumpin' up and down, yellin' ``LOSE! LOSE! LOSE!'' and Stallman walked in and started jumpin' up and down with me, and we was both jumpin' up and down, yellin', ``LOSE! LOSE! LOSE! LOSE!!'' and some professor came over, gave me a 6-3 degree, sent me down the hall, said ``You're our distinguished lecturer.'' Didn't feel too good about it.

Proceeded down the infinite corridor, gettin' more inspections, rejections (this IS MIT), detections, neglections, and all kinds of stuff that they was doin' to me there, and I was there for two years... three years... four years... I was there for a long time goin' through all kinds of mean, nasty, kludgy things, and I was havin' a tough time there, and they was inspectin', injectin', every single part of me, and they was leavin' no part unbound!

Proceeded through, and I finally came to see the very last man. I walked in, sat down, after a whole big thing there. I walked up, and he said, ``Kid, we only got one question: Have you ever been arrested''?

And I proceeded to tell him the story of the half-a-meg of garbage with full orchestration and five-part harmony and stuff like that, and other phenomenon.

He stopped me right there and said, ``Kid, have you ever been to court''? And I proceeded to tell him the story of the seventeen 1K-by-32 pixel multi-flavored windows with turds and arrows and documentation panes...

He stopped me right there and said, ``Kid, I want you to go over and sit down on that bench that says `LISP Machine Group'... NOW, KID!''

And I walked over to the bench there, and there's... The LISP Machine Group is where they put you if you may not be moral enough to join Symbolics after creatin' your special form.

There was all kinds of mean, nasty, ugly-lookin' people on the bench there ... there was Microcoders, DPL hackers, File System hackers, and Window System Hackers!! Window System hackers sittin' right there on the bench next to me! And the meanest, ugliest, nastiest one... the kludgiest Window System hacker of them all... was comin' over to me, and he was mean and ugly and nasty and horrible and all kinds of things, and he sat down next to me. He said, ``Kid, you get a new copy of the sources?'' I said, ``I didn't get nothin'. I had to rebuild the world load.''

He said, ``What were you arrested for, kid?'' and I said, ``Littering...'' And they all moved away from me on the bench there, with the hairy eyeball and all kinds of mean, nasty things, 'til I said, ``And making gratuitous modifications to LMIO; sources...'' And they all came back, shook my hand, and we had a great time on the bench talkin' about microcoding, DPL designing, file-system hacking, .... and all kinds of groovy things that we was talkin' about on the bench, and everything was fine.

We was drinking Coke, smoking all kinds of things, until the RA came over, had some paper in his hand, held it up and said:

``KIDS-THIS-EXAM-S-GOT-FOURTY SEVEN-WORDS-THIRTY-SEVEN-MULTIPLE-CHOICE-QUESTIONS FIFTY-EIGHT-WORDS-WE-WANT-TO-KNOW-THE-DETAILS OF-THE-HACK-THE-TIME-OF-THE-HACK-AND-ANY OTHER-KIND-OF-THING-YOU-GOT-TO-SAY PERTAINING-TO-AND-ABOUT-THE-HACK-ANY-OTHER KIND-OF-THING-YOU-GOT-TO-SAY-WE-WANT-TO-KNOW THE-ARRESTED-PROCESS'-NAME-AND-ANY OTHER-KIND-OF-THING...''

And he talked for forty-five minutes and nobody understood a word that he said. But we had fun rolling the mice around and clickin' on the buttons.

I filled out the special form with the four-level macro defining macros. Typed it in there just like it was and everything was fine. And I put down my keyboard, and I switched buffers, and there ... in the other buffer... centered in the other buffer... away from everything else in the buffer... in parentheses, capital letters, backquotated, in 43VXMS, read the following words: ``Kid, have you featurized yourself''?

I went over to the RA. Said, ``Mister, you got a lot of damned gall to ask me if I've featurized myself! I mean, I mean, I mean that you send, I'm sittin' here on the bench, I mean I'm sittin' here on the Lisp Machine Group bench, 'cause you want to know if I'm losing enough to join the Lab, burn PROMs, power supplies, and documentation, after bein' on SF-LOVERS?''

He looked at me and said, ``Kid, we don't like your kind! We're gonna send your user-id off to the DCA in Washington''! And, friends, somewhere in Washington, enshrined on some little floppy disk, is a study in ones and zeros of my brain-damaged programming style...

And the only reason I'm singin' you the song now is 'cause you may know somebody in a similar situation. Or you may be in a similar situation, and if you're in a situation like that, there's only one thing you can do:

(Chorus)

You know, if one person, just one person, does it, they may think he's really dangerous and they won't take him.
And if two people do it, in harmony, they may think they're both LISP hackers and they won't take either of them.
And if three people do it! Can you imagine three people walkin' in, singin' a bar of ``MIT's AI Lab'' and walkin' out? They may think it's an re-implementation of the window system!
And can you imagine fifty people a day? I said FIFTY people a day, walkin' in, singin' a bar of ``MIT's AI Lab'' and walkin' out? Friends, they may think it's a MOVEMENT, and that's what it is: THE MIT AI LAB ANTI-LOSSAGE MOVEMENT! And all you gotta do to join is to sing it the next time it comes around on the circular buffer.
With feelin'.
You can hack anything you want
on MIT Lisp Machines
You can hack anything you want
on MIT Lisp Machines
Walk right in and begin to hack
Just push your stuff right onto the stack
You can hack anything you want
on MIT Lisp Machines

(but don't forget to fix the bug...on MIT Lisp Machines!)

(Converted to html by tfb from a TeX version I made a long time ago. If anyone has the original of this, let me know.)